using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Instance.Models;

internal record Identifier(int Id, string PaddedId)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, IdentifierSourceGenerationContext.Default.Identifier);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Identifier))]
internal partial class IdentifierSourceGenerationContext : JsonSerializerContext
{
}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Identifier[]))]
internal partial class IdentifierCollectionSourceGenerationContext : JsonSerializerContext
{
}