using System.Collections.ObjectModel;
using View_by_Distance.Shared.Models;

namespace View_by_Distance.Map.Models.Stateless.Methods;

public interface IMapLogic
{

    ReadOnlyDictionary<int, List<long>> TestStatic_GetIdToPersonKeys(ReadOnlyDictionary<long, List<int>> personKeyToIds) =>
        GetIdToPersonKeys(personKeyToIds);
    static ReadOnlyDictionary<int, List<long>> GetIdToPersonKeys(ReadOnlyDictionary<long, List<int>> personKeyToIds) =>
        MapLogic.GetIdToPersonKeys(personKeyToIds);

    ReadOnlyCollection<Face> TestStatic_GetFaces(ReadOnlyCollection<Item> items) =>
         GetFaces(items);
    static ReadOnlyCollection<Face> GetFaces(ReadOnlyCollection<Item> items) =>
        MapLogic.GetFaces(items);

    Mapping[] TestStatic_GetSelectedMappingCollection(ReadOnlyCollection<Item> items) =>
        GetSelectedMappingCollection(items);
    static Mapping[] GetSelectedMappingCollection(ReadOnlyCollection<Item> items) =>
        MapLogic.GetSelectedMappingCollection(items);

    Mapping[] TestStatic_GetSelectedMappingCollection(ReadOnlyCollection<Face> faces) =>
        GetSelectedMappingCollection(faces);
    static Mapping[] GetSelectedMappingCollection(ReadOnlyCollection<Face> faces) =>
        MapLogic.GetSelectedMappingCollection(faces);

    ReadOnlyDictionary<int, ReadOnlyDictionary<int, Mapping>> TestStatic_GetIdToWholePercentagesToFace(ReadOnlyCollection<Mapping> distinctValidImageMappingCollection) =>
        GetIdToWholePercentagesToFace(distinctValidImageMappingCollection);
    static ReadOnlyDictionary<int, ReadOnlyDictionary<int, Mapping>> GetIdToWholePercentagesToFace(ReadOnlyCollection<Mapping> distinctValidImageMappingCollection) =>
        MapLogic.GetIdToWholePercentagesToFace(distinctValidImageMappingCollection);

    List<(string, long)> TestStatic_GetJLinkDirectories(string genealogicalDataCommunicationFile, string[] jLinks, string personBirthdayFormat, char[] personCharacters, string a2PeopleSingletonDirectory, string a2PeopleContentDirectory) =>
         GetJLinkDirectories(genealogicalDataCommunicationFile, jLinks, personBirthdayFormat, personCharacters, a2PeopleSingletonDirectory, a2PeopleContentDirectory);
    static List<(string, long)> GetJLinkDirectories(string genealogicalDataCommunicationFile, string[] jLinks, string personBirthdayFormat, char[] personCharacters, string a2PeopleSingletonDirectory, string a2PeopleContentDirectory) =>
        MapLogic.GetJLinkDirectories(genealogicalDataCommunicationFile, jLinks, personBirthdayFormat, personCharacters, a2PeopleSingletonDirectory, a2PeopleContentDirectory);

    void TestStatic_SetCreationTime(MappingFromItem mappingFromItem, ReadOnlyCollection<LocationContainer> locationContainers) =>
        SetCreationTime(mappingFromItem, locationContainers);
    static void SetCreationTime(MappingFromItem mappingFromItem, ReadOnlyCollection<LocationContainer> locationContainers) =>
        DecadeLogic.SetCreationTime(mappingFromItem, locationContainers);

    void TestStatic_MoveToDecade(Property.Models.Configuration propertyConfiguration, MappingFromItem mappingFromItem, ReadOnlyCollection<LocationContainer> locationContainers) =>
        MoveToDecade(propertyConfiguration, mappingFromItem, locationContainers);
    static void MoveToDecade(Property.Models.Configuration propertyConfiguration, MappingFromItem mappingFromItem, ReadOnlyCollection<LocationContainer> locationContainers) =>
        DecadeLogic.MoveToDecade(propertyConfiguration, mappingFromItem, locationContainers);

    bool? TestStatic_CanReMap(long[] jLinkResolvedPersonKeys, ReadOnlyDictionary<int, ReadOnlyCollection<PersonContainer>>? wholePercentagesToPersonContainers, MappingFromLocation mappingFromLocation) =>
        CanReMap(jLinkResolvedPersonKeys, wholePercentagesToPersonContainers, mappingFromLocation);
    static bool? CanReMap(long[] jLinkResolvedPersonKeys, ReadOnlyDictionary<int, ReadOnlyCollection<PersonContainer>>? wholePercentagesToPersonContainers, MappingFromLocation mappingFromLocation) =>
        MapLogic.CanReMap(jLinkResolvedPersonKeys, wholePercentagesToPersonContainers, mappingFromLocation);

    string TestStatic_GetDecade(MappingFromItem mappingFromItem) =>
        GetDecade(mappingFromItem);
    static string GetDecade(MappingFromItem mappingFromItem) =>
        DecadeLogic.GetDecade(mappingFromItem, null);

}