using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public record ContentProperties(
    [property: JsonPropertyName("contentDate")] DateTime ContentDate,
    [property: JsonPropertyName("contentSignatures")] IReadOnlyList<ContentSignature> ContentSignatures,
    [property: JsonPropertyName("contentType")] string ContentType,
    [property: JsonPropertyName("extension")] string Extension,
    [property: JsonPropertyName("image")] ImageAmazon Image,
    [property: JsonPropertyName("md5")] string Md5,
    [property: JsonPropertyName("size")] int Size,
    [property: JsonPropertyName("version")] int Version
);

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(ContentProperties))]
public partial class ContentPropertiesGenerationContext : JsonSerializerContext
{
}